<?php
   /*
   Plugin Name: WP Tube Tracker V2
   Plugin URI: www.wptubetracker.com
   Description: Determine your rankings in the YouTube and Google search engines, for any video!
   Version: 2.0
   Author: Aaron Sammon
   Author URI: http://aaronsammon.com
   */

/*****************
* Global Variables
******************/
$YT101_prefix = 'YT101_';
$YT101_plugin_name = 'Youtube Rank';
define('YT101_LOCATION', WP_PLUGIN_URL . '/'.basename(dirname(__FILE__)));
include ('csv.php');
/*Retrieve our plugin settings from the options table*/
$YT101_options = get_option('YT101_settings');
error_reporting(E_ERROR);
ini_set('display_errors', 1);

/**********Installing DB****************************/
global $YT101_db_version;
$YT101_db_version = "2.0";

function YT101_install() {
   global $wpdb;
   global $YT101_db_version;
  // ini_set("memory_limit","16M");

   $table_name = $wpdb->prefix . "WPTT";
      
   $table = "CREATE TABLE IF NOT EXISTS $table_name (id int(10) NOT NULL AUTO_INCREMENT,
   time datetime NOT NULL, 
   keyword VARCHAR(255) NOT NULL,
   url VARCHAR(255) NOT NULL,
   rank int(255) NOT NULL,
   oldrank int(255) NOT NULL,
   googlelocation VARCHAR(255) NOT NULL,
   googlerank int(255) NOT NULL,
   googleoldrank int(255) NOT NULL,
   ytcalc int(255),
   googlecalc int(255),
   UNIQUE KEY id (id) );";

  

  
	require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
	dbDelta($table);
 
	add_option("YT101_db_version", $YT101_db_version);

	$wpdb->query("ALTER TABLE $table_name ADD COLUMN `ytcalc` INT(255)");
	$wpdb->query("ALTER TABLE $table_name ADD COLUMN `googlecalc` INT(255)");
        $wpdb->query("ALTER TABLE $table_name ADD COLUMN `group` VARCHAR(255) DEFAULT 'Change here' NOT NULL");
        $wpdb->query("ALTER TABLE $table_name ADD COLUMN `desc` VARCHAR(255)");
        $wpdb->query("ALTER TABLE $table_name ADD COLUMN `mc` VARCHAR(255)");
        $wpdb->query("ALTER TABLE $table_name ADD COLUMN `updated` INT(255) DEFAULT 0");
        $wpdb->query("ALTER TABLE $table_name ADD COLUMN `starred` INT(255) DEFAULT 0");
        $wpdb->query("ALTER TABLE $table_name ADD COLUMN `status` VARCHAR(255) DEFAULT 'play'");
        
}

register_activation_hook(__FILE__,'YT101_install');



function YT101_scripts() {

wp_register_script('jquery', 'https://ajax.googleapis.com/ajax/libs/jquery/1.6.1/jquery.min.js', false, '1.6.1', false);
wp_enqueue_script('jquery');

}	
add_action( 'wp_enqueue_scripts', 'YT101_scripts' );  	




/*Used in Adding New Searches*/
function new_query($data)
{
	global $wpdb;
	 $table_name = $wpdb->prefix . "WPTT";
	$wpdb->insert($table_name, $data);
		  
 }
 
 function check_rank($data)
{
	global $wpdb;
	 $table_name = $wpdb->prefix . "WPTT";
	$wpdb->insert($table_name, $data);
		  
 }
function update_yt($data, $tracker)
{
	global $wpdb;
	$table_name = $wpdb->prefix . "WPTT";
	
	$wpdb->update( $table_name, array('url'=>$data['url'], 'keyword'=>$data['keyword'], 'group'=>$data['group'], 'desc'=>$data['desc'], 'mc' =>$data['mc']), array('id'=>$tracker));
	

}
function delete($variable)
	{
	global $wpdb;
	$deleterow = $variable;
	$table_name = $wpdb->prefix . "WPTT";
	//echo $table_name;
	$wpdb->query($wpdb->prepare("DELETE FROM $table_name WHERE id ='%d'",$deleterow ));
	}
	
        

function wptubetracker_update()
     {
      if ($_GET['page_id'] == "wptubetracker_update") 
	{  
            global $wpdb;
           $thetime = time();
          
           
           print_r($thetime);
        
           $table_name = $wpdb->prefix . "WPTT";

        
           $fivesdrafts = $wpdb->get_results("SELECT * FROM  $table_name WHERE updated <= $thetime AND status = 'play' ORDER BY updated ASC LIMIT 3", "ARRAY_A");

           foreach ( $fivesdrafts as $fivesdraft )
           {
                   update_all_rankings($fivesdraft['url'], $fivesdraft['keyword'], $fivesdraft['rank'], $fivesdraft['googlerank'] );
           }
            exit();										 
}
     }
add_action('parse_request', 'wptubetracker_update');			
	

/*****************DASHBOARD*********************/
function YT101_options_page_main() {
	global $wpdb;
			$table_name = $wpdb->prefix . "WPTT";
		global $YT101_options;
		
		if (isset($_GET['group'])&& !empty($_GET['group']))
		{
                    $tracker = urldecode($_GET['group']);
                 }
                                                
		if (isset($_GET['id'])&& !empty($_GET['id']))
		{
		delete($_GET['id']);
		}
		
		$order = ($_GET['order'] == 'asc') ? 'asc' : 'desc';
	    $new_order = ($order == 'asc' ) ? 'desc' : 'asc';
		
		if (isset($_GET['orderBy'])&& !empty($_GET['orderBy']))
		{
		$field = $_GET['orderBy'];
                        
		}
		else
		{
		$order = 'asc';
		$field = 'id';
		
		}
		?>
		<div class="YT101wrap">
		<div id="header">
			<center><a href="http://wptubetracker.com"><img src="<?php echo YT101_LOCATION; ?>/images/headeradmin.jpg" /></a></center>
			<!--<div style=" margin-left:220px;"><p>For more information and access to our amazing addons, please visit <a href="http://wptubetracker.com">http://WPTubeTracker.com</a>. </p> </div>-->
			
		</div>
		
			<div id="optionspanel">
			<br />
			   <div class="option">
                        	<h3 style="float:left; margin-right: 100px;"> <?php _e('Select your Client/Project to display', 'ap101_domain');?></h3>
                            <select name="yt101clientselect" id="yt101clientselect" class="textfield" style="float:left; margin-top:10px !important;" onchange="location = this.options[this.selectedIndex].value;">
                            	<?php
                                
                                $clientresults= $wpdb->get_results("SELECT * FROM  $table_name", "ARRAY_A");
                                $clientarray = array();
                                foreach($clientresults as $clientresult)
                                {
                                    if(!array_key_exists($clientresult['group'], $clientarray))
                                    {
                                        $clientarray[$clientresult['group']] = $clientresult['group'];
                                    }
                                }
                                 echo '<option value="admin.php?page=YT101-menu">All</option>';
                                foreach($clientarray as $group)
                                {
                                    if(!empty($group))
                                    {
                                    echo '<option value="admin.php?page=YT101-menu&group='.urlencode($group) . '"';
                                            if(($_GET['group'] == $group))
                                             {
                                                echo 'selected="selected"';
                                                
                                                }
                                            
                                         echo  '>'.$group.'</option>';
                                    }
                                }
                                
                                ?>
                                    
                                     
                                        
                                 
   
                                   </select>
				
                               
                                <br class="clear"/>   
                    </div>
			<form method="post" name="deleteform" action="">
			<?php 
			
			/*Variables etc*/
			global $wpdb;
			$table_name = $wpdb->prefix . "WPTT";
			$keywords=count($wpdb->get_results("SELECT * FROM $table_name"));
			/*echo '<div class ="keywords">';
			echo '<p><b>Keyword Limit:</b>';*/
			if ($keywords <= 100000)
			{
			/* $keywords .'/25 </p>';
			echo '</div>';*/
			echo '<br />';
			/*Table for displaying results*/
			echo '<table width="100%" id="keyword_rankings" class="widefat" cellspacing="0" style="width:1000px;">';
			echo '<thead>';
			echo '<tr>';
				//echo '<th><a href="admin.php?page=YT101-menu&orderBy='.$orderBy = '`group`'. '&order='.$new_order.'">Client/Project Group</a></th>';
				echo '<th></th>';
				echo '<th><a href="admin.php?page=YT101-menu&orderBy='.$orderBy = 'keyword,'.get_option('yt101_sorting').'&order='.$new_order.'&group='.urlencode($_GET['group']).'">Keyword</a></th>';
				//echo '<th><a href="admin.php?page=YT101-menu&orderBy='.$orderBy = '`desc`'. '&order='.$new_order.'">Short Desc</a></th>';
                              
				echo '<th><a href="admin.php?page=YT101-menu&orderBy='.$orderBy = 'url,'.get_option('yt101_sorting').'&order='.$new_order.'&group='.urlencode($_GET['group']).'">Video ID</a></th>';
                                  echo '<th><a href="admin.php?page=YT101-menu&orderBy='.$orderBy= 'mc,'.get_option('yt101_sorting').'&order='.$new_order.'&group='.urlencode($_GET['group']).'">M/C</a></th>';
				echo '<th><a href="admin.php?page=YT101-menu&orderBy='.$orderBy = 'rank = 0, rank'. '&order='.$new_order.'&group='.urlencode($_GET['group']).'">YT Rank/100</a></th>';
				echo '<th><a href="admin.php?page=YT101-menu&orderBy='.$orderBy = 'ytcalc'. '&order='.$new_order.'&group='.urlencode($_GET['group']).'">Change</a></th>';
				echo '<th><a href="admin.php?page=YT101-menu&orderBy='.$orderBy = 'googlerank = 0, googlerank'. '&order='.$new_order.'&group='.urlencode($_GET['group']).'">Google Rank/100</a></th>';
				echo '<th><a href="admin.php?page=YT101-menu&orderBy='.$orderBy = 'googlecalc'. '&order='.$new_order.'&group='.urlencode($_GET['group']).'">Change</a></th>';
				echo '<th><a href="admin.php?page=YT101-menu&order='.$new_order.'&group='.urlencode($_GET['group']).'">Edit</a></th>';
				echo '<th><a href="admin.php?page=YT101-menu&order='.$new_order.'&group='.urlencode($_GET['group']).'">Delete</a></th>';
				echo '<th><a href="admin.php?page=YT101-menu&orderBy='.$orderBy = 'status'.'&order='.$new_order.'&group='.urlencode($_GET['group']).'">Pause?</a></th>';
				echo '<th><a href="admin.php?page=YT101-menu&orderBy='.$orderBy = 'updated'.'&order='.$new_order.'&group='.urlencode($_GET['group']).'">Last Updated</a></th>';
			echo '</tr>';
				echo '</thead>';
			  $csv_hdr = "Keyword, Video ID, M/C, YT Rank/100, Change, Google Rank/100, Change, Last Updated";
					/*Object*/
					//$orderBy = 'id';
					
					if (isset($_GET['group'])&& !empty($_GET['group']))
						{
							$tracker = urldecode($_GET['group']);
							
							$fivesdrafts = $wpdb->get_results("SELECT * FROM  $table_name WHERE `group` = '$tracker' ORDER BY $field $order ", "ARRAY_A");
							
						}
						
						else
						{
							$fivesdrafts = $wpdb->get_results("SELECT * FROM  $table_name ORDER BY $field $order ", "ARRAY_A");
						}

							foreach ( $fivesdrafts as $fivesdraft )
							{
							
							$desc = $fivesdraft['desc'];
							$desc = substr($desc,0,60).'...';
								$deleterow = $fivesdraft['id'];//The row ID to delete, this will loop for every single KW search row
								echo '<tr>';
								//print_r('<td><b><a href="admin.php?page=YT101-menu&group='.$fivesdraft['group'].'">'. $fivesdraft['group'] . '</a></b></td>');
								//$csv_output .= $fivesdraft['group'] . ", ";
                                                                if($fivesdraft['starred'] == 1)
                                                                {
                                                                    print_r('<td><img class="starred" src="'. YT101_LOCATION . '/images/starred.png" data-id="'.$fivesdraft['id'].'" style="cursor:pointer;"/></td>');
                                                                }
                                                                else
                                                                {
                                                                   print_r('<td><img class="notstarred" src="'. YT101_LOCATION . '/images/notstarred.png" data-id="'.$fivesdraft['id'].'" style="cursor:pointer;"/></td>'); 
                                                                }
								
								print_r('<td>'. $fivesdraft['keyword'] .'</td>');
								$csv_output .= $fivesdraft['keyword'] . ", ";
								//print_r('<td>'. $desc .'</td>');
								//$csv_output .= $desc . ", ";
								print_r('<td>'. '<a href="http://www.youtube.com/watch?v='. $fivesdraft['url'] .'" target="_blank">'. $fivesdraft['url'] .'</a>'. '</td>');
								$csv_output .= $fivesdraft['url'] . ", ";
                                                                
                                                                
                                                                print_r('<td>'.$fivesdraft['mc'].'</td>');
                                                                $csv_output .= $fivesdraft['mc'] . ", ";
								/*If the rank is out of bounds,it could be an infinite above 100, thus 100+ */
								if($fivesdraft['rank']  == 999)
								
								{
									print_r('<td> 100+</td>');
									$csv_output .= '100+' . ", ";
									print_r('<td>'. '<img src="'. YT101_LOCATION . '/images/down.png"/> ' .'100+</td>');
									$csv_output .= 'DOWN 100+' . ", ";
								
								}
								
								/*If the oldrank is out of bounds, show > 100 */
								elseif ($fivesdraft['oldrank']  == 999 and $fivesdraft['rank'] != 999)
								{
								print_r('<td>'. $fivesdraft['rank'].'</td>');
								$csv_output .= $fivesdraft['rank'] . ", ";
								print_r('<td>'. '<img src="'. YT101_LOCATION . '/images/up.png"/> '. '100+</td>');
								$csv_output .= 'UP 100+' . ", ";
								
								}
								/*If in bounds, subtract new rank from old to see adjustments*/
								else
								{
									print_r('<td>'. $fivesdraft['rank'].'</td>');
									$csv_output .= $fivesdraft['rank'] . ", ";
									$changeofrank = ($fivesdraft['oldrank'] - $fivesdraft['rank']);
								$changeofrank = str_replace('-', '', $changeofrank);
									
									if ($fivesdraft['rank'] < $fivesdraft['oldrank'])
									{
									print_r('<td>'. '<img src="'. YT101_LOCATION .'/images/up.png"/> '.$changeofrank .'</td>');
									$csv_output .= 'UP '. $changeofrank . ", ";
										
									}
									elseif ($fivesdraft['rank'] > $fivesdraft['oldrank'])
									{
									print_r('<td>'. '<img src="'. YT101_LOCATION . '/images/down.png"/> '.$changeofrank  .'</td>');
									$csv_output .= 'DOWN '.$changeofrank . ", ";
									;
									}
									
									else 
									{
										print_r('<td>'. '<img src="'. YT101_LOCATION . '/images/same.png"/> '.'0</td>');
										$csv_output .= '0'. ", ";
										
										
									}
									
								}//end of else
								
								
								/*If the GOOGLE rank is out of bounds,it could be an infinite above 100, thus 100+ */
								if($fivesdraft['googlerank']  == 999)
								
								{
									print_r('<td> 100+</td>');
									$csv_output .= '100+'. ", ";
									print_r('<td>'. '<img src="'. YT101_LOCATION . '/images/down.png"/> '. '100+</td>');
									$csv_output .= 'DOWN 100+'. ", ";
								
								}
								
								/*If the oldrank is out of bounds, show > 100 */
								elseif ($fivesdraft['googleoldrank']  == 999 and $fivesdraft['googlerank'] != 999)
								{
								print_r('<td>'. $fivesdraft['googlerank'].'</td>');
								$csv_output .= $fivesdraft['googlerank']. ", ";
								print_r('<td>'. '<img src="'. YT101_LOCATION . '/images/up.png"/> '.'100+</td>');
								$csv_output .= 'UP 100+'. ", ";
								
								}
								/*If in bounds, subtract new rank from old to see adjustments*/
								else
								{
									print_r('<td>'. $fivesdraft['googlerank'].'</td>');
									$csv_output .= $fivesdraft['googlerank']. ", ";
									$changeofrank = ($fivesdraft['googleoldrank'] - $fivesdraft['googlerank']);
									$changeofrank = str_replace('-', '', $changeofrank);
								
									
									if ($fivesdraft['googlerank'] < $fivesdraft['googleoldrank'])
									{
									print_r('<td>'. '<img src="'. YT101_LOCATION .'/images/up.png"/> '. $changeofrank .'</td>');
										$csv_output .= 'UP '.$changeofrank. ", ";
										
									}
									elseif ($fivesdraft['googlerank'] > $fivesdraft['googleoldrank'])
									{
									print_r('<td>'. '<img src="'. YT101_LOCATION . '/images/down.png"/> '. $changeofrank .'</td>');
									$csv_output .= 'DOWN '.$changeofrank. ", ";
									;
									}
									
									else 
									{
										print_r('<td>'. '<img src="'. YT101_LOCATION . '/images/same.png"/> '.'0</td>');
										
                                                                                $csv_output .= '0'. ", ";
										
										
									}
									
								}//end of else
								
						echo '<td><a href="admin.php?page=YT101-add-keywords&id='.$fivesdraft['id'].'">'. '<img src="'. YT101_LOCATION . '/images/edit.png"/> ' .  '</a></td>';
	
						echo '<td><a onclick="if(!confirm(\'This cannot be reversed, are you sure you want to delete\')) return false;" href="admin.php?page=YT101-menu&id='.$fivesdraft['id'].'">'. '<img src="'. YT101_LOCATION . '/images/delete.png"/> ' . '</a></td>';
                                                  
                                                if($fivesdraft['status'] == 'play')
                                                                {
                                                                    print_r('<td><img class="play" src="'. YT101_LOCATION . '/images/button_blue_pause.png" data-id="'.$fivesdraft['id'].'" style="cursor:pointer;"/></td>');
                                                                }
                                                                else
                                                                {
                                                                   print_r('<td><img class="pause" src="'. YT101_LOCATION . '/images/button_blue_play.png" data-id="'.$fivesdraft['id'].'" style="cursor:pointer;"/></td>'); 
                                                                }
                                                
                                                
                                                
                                                
                                                if($fivesdraft['updated'] == 0)
                                                    {
                                                            print_r('<td>Never</td>');
                                                            $csv_output .= 'Never'. "\n";
                                                    }
                                                    else{
                                                            print_r('<td>'. date('m/d/Y H:i:s', $fivesdraft['updated']).'</td>');
                                                            $csv_output .=  date('m/d/Y H:i:s', $fivesdraft['updated']). "\n";
                                                            
                                                    }
                                                
						echo '</tr>';
							}
						
				  echo '</table>';
		
}
			?>
		
				</form>

				<br />
<center>
<form name="export" action="<?php echo YT101_LOCATION; ?>/csv.php" method="post">
    <input type="submit" class="button-primary" value="Export Results">
    <input type="hidden" value="<?php echo $csv_hdr; ?>" name="csv_hdr">
    <input type="hidden" value="<?php echo $csv_output; ?>" name="csv_output">
</form>
</center>
					</div>
	
			</div><!--YT101-->
		<br clear="all"/>
	
<link type="text/css" rel="stylesheet" href="<?php echo YT101_LOCATION; ?>/css/YT101-admin.css" />
<script>
jQuery(document).ready(function($) {
       
	$('img.starred').click(function() {
            
            
           jQuery(this).attr('src','<?php echo  YT101_LOCATION;?>/images/notstarred.png'); 
           
              
            $id = jQuery(this).attr("data-id");
             var data = {
		action: 'yt101_starred',
		id: $id
               
	};

            // since 2.8 ajaxurl is always defined in the admin header and points to admin-ajax.php
            $.post(ajaxurl, data, 
            function(response) {
                    location.reload();
                   
            });
        
        });
        
        $('img.notstarred').click(function() {
                  jQuery(this).attr('src','<?php echo  YT101_LOCATION;?>/images/starred.png'); 
             
            $id = jQuery(this).attr("data-id");
             var data = {
		action: 'yt101_notstarred',
		id: $id
               
	};

            // since 2.8 ajaxurl is always defined in the admin header and points to admin-ajax.php
            $.post(ajaxurl, data, 
            function(response) {
                location.reload();  
            });
        
        });
        
        
        $('img.play').click(function() {
            
            
           jQuery(this).attr('src','<?php echo  YT101_LOCATION;?>/images/button_blue_play.png'); 
            $id = jQuery(this).attr("data-id");
             var data = {
		action: 'yt101_play',
		id: $id
               
	};

            // since 2.8 ajaxurl is always defined in the admin header and points to admin-ajax.php
            $.post(ajaxurl, data, 
            function(response) {
                    location.reload();
                   
            });
        
        });
        
         $('img.pause').click(function() {
            
            
           jQuery(this).attr('src','<?php echo  YT101_LOCATION;?>/images/button_blue_pause.png'); 
            $id = jQuery(this).attr("data-id");
             var data = {
		action: 'yt101_pause',
		id: $id
               
	};

            // since 2.8 ajaxurl is always defined in the admin header and points to admin-ajax.php
            $.post(ajaxurl, data, 
            function(response) {
                    location.reload();
                   
            });
        
        });
        
	
});

</script>
<?php

}		
		
		
/****************ADDING NEW SEARCHES PAGE*******************************************************************************************************/


		function YT101_options_page_add() {

	
		global $wpdb;
		$table_name = $wpdb->prefix . "WPTT";
		
		//our edit stuff
		if (isset($_GET['id'])&& !empty($_GET['id']))
		{
		$tracker = $_GET['id'];
		?><script>
		jQuery(document).ready(function() {
			jQuery('input[name^=group]').click(function() {
			jQuery(this).val('');	
			});
		});
	</script><?php
	
		$fivesdrafts = $wpdb->get_results("SELECT * FROM  $table_name WHERE id = $tracker", "ARRAY_A");
		foreach ($fivesdrafts as $fivesdraft)
			{
			//This will get the data for our edit fields.
			$dburl = $fivesdraft['url'];
			$dbkeyword = $fivesdraft['keyword'];
			$dbgroup = $fivesdraft['group'];
			$dbdesc= $fivesdraft['desc'];
			$yt101mc= $fivesdraft['mc'];
			}
	
	}
		
		
		if($_POST)
		{
 		$url=$_POST['url'];
 		$keyword=$_POST['keywords'];
 		$group=$_POST['group'];
 		$desc=$_POST['desc'];
		
		}
		
		$keywords=count($wpdb->get_results("SELECT * FROM $table_name"));

		
			if($_POST['submit'])
			{
				if (isset($_GET['id'])&& !empty($_GET['id']))
				{
                                    
                                    //This is for the edit
					if ($url !='' && $keyword !='' )
					{
					$data['url']= trim($_POST['url']);
					
                                        
					$data['group']= trim($_POST['group']);
					$data['mc']= trim($_POST['yt101mc']);
					$data['desc']= trim($_POST['desc']);
                                        
                                       
                                        $keywords = array();
                                        $kwdata = trim($_POST['keywords']);
                                 

                                        //explode all separate lines into an array
                                        $textAr = explode("\n", stripslashes($kwdata));

                                        //trim all lines contained in the array.
                                        $textAr = array_filter($textAr, 'trim');

                                        trim($textAr);
                                       // var_dump($textAr);

                                        foreach($textAr as $line){
                                           $keywords[$line] = trim($line);
                                        }

                                        $trimmed_array=array_map('trim',$keywords);


                                            
                                        $counter = 0;
                                        //this counter makes sure we only add the 1 kw to the update list, mini hack..
                                        foreach($trimmed_array as $search)
                                        {
                                            if($counter > 1)
                                            {
                                                break;
                                            }
                                            else
                                                {
                                                $data['keyword'] = $search;
                                                update_yt($data, $tracker);
                                            }
                                         
                                          $counter++; 
                                            
                                        }?>
					<script>
                                            window.location.replace("admin.php?page=YT101-menu");
					</script><?php
					}
				
                                    }
                              
                                //This is for a new result
				elseif ($url !='' && $keyword !='' && $keywords <= 100000)
				{
				
					$data['url']= trim($url);
					$data['group']= trim($group);
					$data['desc']= trim($desc);
					$data['rank'] = 999;
					$data['oldrank'] = 999;
					$data['googleoldrank'] = 999;
					$data['googlelocation'] = "com";
					$data['googlecalc'] = 100;
					$data['ytcalc'] = 100;
					$data['googlerank'] = 999;
					$data['mc'] = $_POST['yt101mc'];                                        
					$data['starred'] = 0;                                        
                                        
                                        
                                         $keywords = array();
                                        $kwdata = trim($_POST['keywords']);
                                 
                                        //explode all separate lines into an array
                                        $textAr = explode("\n", stripslashes($kwdata));

                                        //trim all lines contained in the array.
                                        $textAr = array_filter($textAr, 'trim');

                                        trim($textAr);
                                        //var_dump($textAr);

                                        foreach($textAr as $line){
                                           $keywords[$line] = trim($line);
                                        }

                                        $trimmed_array=array_map('trim',$keywords);


                                            
                                        
                                        foreach($trimmed_array as $search)
                                        {             
                                            $data['keyword'] = $search;
                                            new_query($data);          
                                           // print_r($search);
                                        }

                                       ?>
					<script>
					window.location.replace("admin.php?page=YT101-menu");
					</script>
                                            <?php
				
				}
				
				else
				{	
				echo ("<script language='javascript'>alert('You have reached your keyword limit or your fields are empty. Please remove some from your dashboard, or upgrade!')</script>"); 
				}
		}
                        
		?>
		
		
<div class="YT101wrap">
		<div id="header">
			<center><a href="http://wptubetracker.com"><img src="<?php echo YT101_LOCATION; ?>/images/headeradmin.jpg" /></a></center>
		
		
		</div>
		
		<div id="optionspanel">
<form name="query_form" method="post">

<h2> Brief Instructions</h2>
		<p>Please add a new search query by performing the following steps: </p>
		
		<p>
		<ol>
		<li> Strip out the ending of the YouTube URL to get the tag - eg: http://www.youtube.com/watch?v=oHg5SJYRHA0 would be - <b>oHg5SJYRHA0</b>.</li>
		<li> Add the appropriate keyword you're hoping to rank this video for.</li>
		<li> Click Save </li>
		<li> Go back to the dashboard, and perform your search. </li>
		</ol>
		</p>

				
		<P style="text-align:right; margin-right: 120px;"><b>Keyword Limit: <?php echo $keywords;?> / ~ </b></p>
	<div class="option">
                        	<h3> <?php _e('Youtube Video Tag ', 'YT101_domain');?></h3>
                            <div class="section">
                            	<div class="element"><input type="text" name="url" value="<?php echo $dburl; ?>" size="30"></div>
							<div class="description">This is the tag for the video, eg - <b>oHg5SJYRHA0</b>.</div>
                            </div>
		</div>

		<div class="option">
                        	<h3> <?php _e('Keyword ', 'YT101_domain');?></h3>
                            <div class="section">
                            	<div class="element"><textarea name="keywords" style="width:335px;" size="30"><?php echo $dbkeyword; ?></textarea></div>
							<div class="description">This is the KW you want to query, eg - <b>Coffee Machines</b>.</div>
                            </div>
		</div>
			<div class="option">
                        	<h3> <?php _e('Client/Project Group ', 'YT101_domain');?></h3>
                            <div class="section">
                            	<div class="element"><input type="text" name="group" value="<?php echo $dbgroup; ?>" size="30"></div>
							<div class="description">An optional category for assigning keywords to groups eg - <b>Client 1 Videos</b>.</div>
                            </div>
		</div>
		
		<!--<div class="option">
                 <h3> <?php _e('Short Description (< 60 chars) ', 'YT101_domain');?></h3>
				  <div class="section">
				<div class="element"><textarea id="desc" rows="3" style="width:335px;" name="desc"><?php echo $dbdesc?></textarea></div>
				<div class="description">A short description field to help distinguish between videos on the dashboard</div>
                            </div>
		
		</div>
		-->
	
                
                 <div class="option">
                        	<h3> <?php _e('Video Tracker - Mine(M)/Competitors(C)', 'ap101_domain');?></h3>
                            <div class="section">
                            	<div class="element">
                                    <select name="yt101mc" id="yt101mc" class="textfield">
                                        <option value="M" <?PHP if($yt101mc == 'M'){echo 'selected="selected"';} ?>>Mine(M)</option>
                                        <option value="C" <?PHP if($yt101mc == 'C'){echo 'selected="selected"';} ?>>Competitors(C)</option>
                                 
                                 
                                 
                                 
   
                                   </select>
				</div>
                                <div class="description">This allows us to quickly distinguish which videos are ours, and which videos are our competitors on the dashboard. </div>
                            </div>
                    </div>
                
                
                
               
				<p class="submit">
				<input class="button-primary" type="submit" name ="submit" value="Save Options ">
				</p>
				</form>
</div>
<br clear="all"/>
		</div>
		
		
	
<link type="text/css" rel="stylesheet" href="<?php echo YT101_LOCATION; ?>/css/YT101-admin.css" />

<?php
}
/*************************************************************************************************************************************************/

	
function YT101_update_page() {
	
		
	}
	
function update_all_rankings($urldata, $keyworddata, $currentrank, $currentgooglerank)
{
		ini_set('max_execution_time', 36000);
		ini_set('default_socket_timeout', 660); 
		ini_set('mysql.connect_timeout', 660);
		set_time_limit(0);
		
		$urlpart = $urldata;
		global $wpdb;
		$table_name = $wpdb->prefix . "WPTT";
		
		$baseURL ='http://www.youtube.com/results?search_query=';
		$baseGoogleURL ='http://www.google.'.get_option('yt101_defaultsearchengine').'/search?q=';
		$pagenumber = '&page=1';
		$pagenumber2 = '&page=2';
		$pagenumber3 = '&page=3';
		$pagenumber4 = '&page=4';
		$pagenumber5 = '&page=5';
		
		$start0 = '';
		$start1 = '&start=10';
		$start2 = '&start=20';
		$start3 = '&start=30';
		$start4 = '&start=40';
		$start5 = '&start=50';
		$start6 = '&start=60';
		$start7 = '&start=70';
		$start8 = '&start=80';
		$start9 = '&start=90';
		
		$newKeyword= str_replace(" ","+",  $keyworddata);
	
	
		$search = $baseURL . "" . $newKeyword;
		$googleurl = $baseGoogleURL . "" . $newKeyword ;
		$x = 1;
		$i = 1;
		
		//Youtube URLs
		$urls = array($search ."". $pagenumber, $search ."". $pagenumber2, $search ."". $pagenumber3, $search ."". $pagenumber4, $search ."". $pagenumber5);
		//Google URLs
		$googleurls = array($googleurl ."". $start0, $googleurl ."". $start1, $googleurl ."". $start2, $googleurl ."". $start3, $googleurl ."". $start4, $googleurl ."". $start5, $googleurl ."". $start6, $googleurl ."". $start7, $googleurl ."". $start8, $googleurl ."". $start9,);

		
		
		//yt
		
		foreach ($urls as $url)
		{
                    $html = scraper($url);
                    $dom = new DOMDocument();
                    @$dom->loadHTML($html);
                    $xPath = new DOMXPath($dom);
                    $nodelist = $xPath->query("//ol[@id='search-results']//div[contains(@class, 'thumbnail')]//a/@href[1]");
     
                    if($nodelist->item(0)) // check if item exists
                    {
                        foreach($nodelist as $node)
                        {
                        //echo $node->nodeValue.'<br>';
                         $latestrank = $x;
                         $pos = strpos($node->nodeValue, $urlpart);

                            if ($pos > 0)
                            {
                                    $data = $latestrank;
                                    $olddata= $currentrank;
                                    
                                    if(get_option('yt101_enableemailreports') == 'yes')
                                    {
                                        yt101email_notification($urldata, $keyworddata, $latestrank, $currentrank, 'Youtube');
                                        
                                    }

                                    break 2;
                            }
                            else
                            {
                            $data = '999';
                            $olddata= $currentrank;
                            }

                            $x++;
                        }

                    }
                    else
                    {

                        $data = $currentrank;
                        $olddata= $currentrank;
                        break;

                    }
		
	
		
            }//end of url loop

		if ($data == '999' || $olddata == '999')
		{
			$changeyt = '100+';
		}
		else
		{
			$changeyt = $olddata - $data;
		}

		$wpdb->update( $table_name, array('rank'=>$data, 'oldrank'=>$olddata,'ytcalc'=>$changeyt  ), array('url'=>$urldata, 'keyword'=>$keyworddata));
		
		
		//google
		foreach($googleurls as $googleurl)
		{	
			
			$html = scraper($googleurl);
			$dom = new DOMDocument();
			@$dom->loadHTML($html);
			$xPath = new DOMXPath($dom);

			$nodelist = $xPath->query("//div[@id='search']//h3[@class='r']//a/@href");
                    if($nodelist->item(0)) // check if item exists
                    {

                        foreach($nodelist as $node)
                        {

                            if(preg_match_all('|url\?q=(.+?)&|', $node->nodeValue, $matches))
                            {

                                //echo urldecode($matches[1][0]).'<br>';

                                $latestrank = $i;

                                $pos = strpos(rawurldecode($matches[1][0]), $urlpart);
                                if ($pos >0)
                                {

                                        $data = $latestrank;
                                        $olddata= $currentgooglerank;
                                          if(get_option('yt101_enableemailreports') == 'yes')
                                            {
                                                yt101email_notification($urldata, $keyworddata, $latestrank, $currentrank, 'Google');

                                            }
                                        YT101_sleeps();
                                        break 2;	

                                }
                                else
                                {

                                $data = '999';
                                $olddata= $currentgooglerank;

                                }
                            }

                          $i++;
                        }


                    }
                 else
		{
                        $data = $currentgooglerank;
                        $olddata= $currentgooglerank;
                        YT101_sleeps();
                        break ;					
		}
			
	  
	  
		YT101_sleeps();
		
		}//end google url loop

		if ($data == '999' || $olddata == '999')
		{
			$changegoogle = '100+';
		}
		else
		{
			$changegoogle = $olddata - $data;
		}


		$wpdb->update( $table_name, array('googlerank'=>$data, 'googleoldrank'=>$olddata,'googlecalc'=>$changegoogle, 'updated'=>time() ), array('url'=>$urldata, 'keyword'=>$keyworddata));
	
//Add some extra time inbetween keywords - 10 seconds
YT101_sleeps();	



}/*end of FUNCTION*/


function YT101_sleeps()
{
sleep(2);
mysql_ping();
sleep(2);
mysql_ping();
sleep(4);
mysql_ping();
sleep(2);
mysql_ping();

}		
function YT101_add_options_link() {
		
			/*Main dashboard*/
			add_menu_page('WP Tube Tracker', 'WP Tube Tracker', 'manage_options', 'YT101-menu', 'YT101_options_page_main');
			
			/*Add Keywords page */	
			add_submenu_page( 'YT101-menu', 'Add New Search', 'Add New Search', 'manage_options', 'YT101-add-keywords', 'YT101_options_page_add' ); 
			add_submenu_page( 'YT101-menu', 'Settings', 'Settings', 'manage_options', 'YT101-settings', 'YT101_settings' ); 
			//add_submenu_page( 'YT101-menu', 'Update Rankings', 'Update Rankings', 'manage_options', 'YT101-update-rankings', 'YT101_update_page' ); 
	
		}

		add_action('admin_menu', 'YT101_add_options_link');
		
// Add to admin_menu function
function YT101_register_settings(){

	//Register the settings
	register_setting('YT101_settings_group', 'YT101_settings');
	register_setting('YT101_settings_group', 'yt101_youtubelanguage');
	register_setting('YT101_settings_group', 'yt101_defaultsearchengine');
	register_setting('YT101_settings_group', 'yt101_emailadmin');
	register_setting('YT101_settings_group', 'yt101_notificationthreshold');
	register_setting('YT101_settings_group', 'yt101_enableemailreports');
	register_setting('YT101_settings_group', 'yt101_youtubelanguage');
	register_setting('YT101_settings_group', 'yt101_defaultsearchengine');
	register_setting('YT101_settings_group', 'yt101_sorting');

	}
	
	

// Default settings 
	add_option( 'YT101_buttoncolor', 'yellow' );
	add_option( 'yt101_youtubelanguage', 'com' );
	add_option( 'yt101_defaultsearchengine', 'com' );
	add_option( 'yt101_emailadmin', 'blah@example.com' );
	add_option( 'yt101_notificationthreshold', '5' );
	add_option( 'yt101_enableemailreports', 'yes' );
	add_option( 'yt101_youtubelanguage', 'com' );
	add_option( 'yt101_defaultsearchengine', 'com' );
	add_option( 'yt101_sorting', 'googlerank' );
	
	
function YT101_settings_page() {
		
		
    // If the save button is pressed:
    if( isset($_POST['saveS']) ) {
		
        // Save the posted value in the database
		update_option('yt101_youtubelanguage', $_POST['yt101_youtubelanguage']);
		update_option('yt101_defaultsearchengine', $_POST['yt101_defaultsearchengine']);

	}
		
}
//Add Actions and Filters		
	add_action('admin_init', 'YT101_register_settings');

/**
 * Simple CURL scraper
 */
function scraper($url, $post_array = false)
{ 
   
    $useragent =  "Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 5.1; bgft)";
    $timeout = 60;
    
    $c = curl_init($url);
    if($post_array)
    {
        $post_string = $this->array_to_post_string($post_array);
        curl_setopt($c, CURLOPT_POST,count($post_array));
        curl_setopt($c, CURLOPT_POSTFIELDS,$post_string);
    }
	
	     curl_setopt($c, CURLOPT_CONNECTTIMEOUT, 1);
		curl_setopt($c, CURLOPT_HEADER, true);
		curl_setopt($c, CURLOPT_USERAGENT, $useragent);
		curl_setopt($c, CURLOPT_FAILONERROR, true);
		curl_setopt($c, CURLOPT_FOLLOWLOCATION, true);
		curl_setopt($c, CURLOPT_AUTOREFERER, true);
		
		curl_setopt($c, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($c, CURLOPT_TIMEOUT, $timeout);
		$ret = curl_exec($c);
		return $ret;
}

/**
 * Converts array to POST string
 */
function array_to_post_string($post_array)
{
    $fields_string = '';
    foreach($post_array as $key=>$value) {
        $fields_string .= urlencode($key).'='.urlencode($value).'&';
    }
    $fields_string = rtrim($fields_string,'&');

    return $fields_string;
}


function YT101_settings()
{
    global $YT101_options;
 ?>   

    
   <div class="YT101wrap">
		<div id="header">
			<center><a href="http://wptubetracker.com"><img src="<?php echo YT101_LOCATION; ?>/images/headeradmin.jpg" /></a></center>
		</div>
		
		<div id="optionspanel">
  <form method="post" action="options.php" >	
			      <?php settings_fields('YT101_settings_group'); ?>	

                 <h2> Cron Settings</h2>
                <p>Cron command: <b> wget <?php echo get_site_url(); ?>/?page_id=wptubetracker_update </b> Please refer to the training videos for instructions.</p>   
 
                <p>To create a cron job:</p>
                
                <ol>
                    <li>Log into cPanel. </li>
                    <li>In the Advanced section, click Cron Jobs. </li>
                    <li>Make sure the current email address is valid. If not, enter a new valid email and click Update Email. You will receive an email after the cron job has finished.     </li>
                    <li>Use the Common Settings to choose from a list of regularly used intervals or set the frequency of your cron job by using the drop-down box next to each setting. </li>
                    <li>Enter in the desired command and click the Add New Cron Job button. </li>
                    <li>We <u>HIGHLY SUGGEST</u> <b> 0 * * * *</b>(hourly) which will update 3 results every hour OR <b> 0,30 * * * *</b>(every 30 mins) </li>
                    <li>You have just created a cron job to execute a file at a certain time and date with the desired repetition. </li>
                </ol>





                     <br />
                     
                     <h2> Search Settings</h2>
		<div class="option">
                        	<h3> <?php _e('Default Search Engine', 'yt101_domain');?></h3>
                            <div class="section">
				<div class="element">
                            	 <select name="yt101_defaultsearchengine" id="yt101_defaultsearchengine" class="textfield">
                                        <option value="com" <?PHP if(get_option('yt101_defaultsearchengine') == 'com'){echo 'selected="selected"';} ?>>google.com</option>
                                    <option value="com.au" <?PHP if(get_option('yt101_defaultsearchengine') == 'com.au'){echo 'selected="selected"';} ?>>google.com.au</option>
                                    <option value="co.uk" <?PHP if(get_option('yt101_defaultsearchengine') == 'co.uk'){echo 'selected="selected"';} ?>>google.co.uk</option>
                                    <option value="ca" <?PHP if(get_option('yt101_defaultsearchengine') == 'ca'){echo 'selected="selected"';} ?>>google.ca</option>
                                    <option value="de" <?PHP if(get_option('yt101_defaultsearchengine') == 'de'){echo 'selected="selected"';} ?>>google.de</option>
                                    <option value="fr" <?PHP if(get_option('yt101_defaultsearchengine') == 'fr'){echo 'selected="selected"';} ?>>google.fr</option>
                                    <option value="ie" <?PHP if(get_option('yt101_defaultsearchengine') == 'ie'){echo 'selected="selected"';} ?>>google.ie</option>
                                        
                                 
   
                                   </select>
                            	 </div>
                            <div class="description">Enter your default search engine where we'll scan for your video.</div>
                            </div>
		</div>
                
      
               
                <!-- <div class="option">
                        	<h3> <?php _e('YouTube Language ', 'yt101_domain');?></h3>
                            <div class="section">
                            	<div class="element">
                                    <select name="yt101_youtubelanguage" id="yt101_youtubelanguage" class="textfield">
                                        <option value="com" <?PHP if(get_option('yt101_youtubelanguage') == 'com'){echo 'selected="selected"';} ?>>English</option>
                                    <option value="fr" <?PHP if(get_option('yt101_youtubelanguage') == 'fr'){echo 'selected="selected"';} ?>>French</option>
                                    <option value="de" <?PHP if(get_option('yt101_youtubelanguage') == 'de'){echo 'selected="selected"';} ?>>German</option>
                                 
                                 
                                 
   
                                   </select>
				</div>
                                <div class="description">Enter the default YouTube language. </div>
                            </div>
                    </div>-->
                     
                       <div class="option">
                        	<h3> <?php _e('Enable Email Reports ', 'yt101_domain');?></h3>
                            <div class="section">
                            	<div class="element">
                                    <select name="yt101_enableemailreports" id="yt101_enableemailreports" class="textfield">
                                        <option value="yes" <?PHP if(get_option('yt101_enableemailreports') == 'yes'){echo 'selected="selected"';} ?>>Yes</option>
                                    <option value="no" <?PHP if(get_option('yt101_enableemailreports') == 'no'){echo 'selected="selected"';} ?>>No</option>
                                    
                                   </select>
				</div>
                                <div class="description">If you want to enable email notifications whenever your video gets into the top X amount of results, click 'Yes'. </div>
                            </div>
                    </div>
                     
                         <div class="option">
                        	<h3> <?php _e('Notification Threshold ', 'yt101_domain');?></h3>
                            <div class="section">
                            	<div class="element">
                                    <select name="yt101_notificationthreshold" id="yt101_notificationthreshold" class="textfield">
                                        <option value="10" <?PHP if(get_option('yt101_notificationthreshold') == '10'){echo 'selected="selected"';} ?>>Top 10</option>
                                    <option value="5" <?PHP if(get_option('yt101_notificationthreshold') == '5'){echo 'selected="selected"';} ?>>Top 5</option>
                                    <option value="3" <?PHP if(get_option('yt101_notificationthreshold') == '3'){echo 'selected="selected"';} ?>>Top 3</option>
                                    <option value="1" <?PHP if(get_option('yt101_notificationthreshold') == '1'){echo 'selected="selected"';} ?>>Top 1</option>
                                    
                                   </select>
				</div>
                                <div class="description">Enter the criteria for the email notifications.</div>
                            </div>
                    </div>
               
                     <div class="option">
                        	<h3> <?php _e('Email Reports To ', 'YT101_domain');?></h3>
                            <div class="section">
                            	<div class="element"><input type="text" name="yt101_emailadmin" value="<?php echo get_option('yt101_emailadmin') ?>" size="50"></div>
							<div class="description">This will be the email the notifications will be sent to.</div>
                            </div>
		</div>
                
                   <div class="option">
                        	<h3> <?php _e('Priority ranking for secondary sorting?', 'yt101_domain');?></h3>
                            <div class="section">
                            	<div class="element">
                                    <select name="yt101_sorting" id="yt101_sorting" class="textfield">
                                        <option value="googlerank" <?PHP if(get_option('yt101_sorting') == 'googlerank'){echo 'selected="selected"';} ?>>Google</option>
                                       <option value="rank" <?PHP if(get_option('yt101_sorting') == 'rank'){echo 'selected="selected"';} ?>>YouTube</option>
                                     
                                    
                                   </select>
				</div>
                                <div class="description">Enter your secondary sorting criteria for when you're filtering by data such as M/C</div>
                            </div>
                    </div>
                
                
                 
				<p class="submit">
				<input class="button-primary" type="submit" name ="submit" value="Save Options ">
				</p>
                
                 
            </form><!--/form-->
</div>
<br clear="all"/>
		</div>
		
		
	
<link type="text/css" rel="stylesheet" href="<?php echo YT101_LOCATION; ?>/css/YT101-admin.css" /> 
    
    <?php  
}

function yt101email_notification($urldata, $keyworddata, $latestrank, $currentrank, $googleyoutube){
    
    
    //Makes sure there has been an actual email entered
    if(get_option('yt101_emailadmin') != 'blah@example.com' && (get_option('yt101_emailadmin')!= ""))
    {
        
       if($currentrank > get_option('yt101_notificationthreshold') && $latestrank <= get_option('yt101_notificationthreshold'))
       {
           
           
           $message = 'Your video with tag: '.$urldata.' and keyword: '.$keyworddata. ' has just entered the top '. get_option('yt101_notificationthreshold'). ' of '.$googleyoutube;
           $to      = get_option('yt101_emailadmin');
           $subject = 'WPTubeTracker V2 Notification';
           $headers = 'From: WPTubeTracker <'.$to.'>' . "\r\n" .
           'Reply-To: WPTubeTracker <'.$to.'>' . "\r\n" .
           'X-Mailer: PHP/' . phpversion();
           mail($to, $subject, $message, $headers);
       }
        

      
    }
    
    
    
}


//Changes to unstarred
add_action('wp_ajax_yt101_starred', 'yt101_starred');
function yt101_starred() {
    
   global $wpdb;
   $id = $_POST['id'] ;
   $table_name = $wpdb->prefix . "WPTT";
   $wpdb->update( $table_name, array('starred'=>'0'), array('id'=>$id));
	
    
}
//changes to starred
add_action('wp_ajax_yt101_notstarred', 'yt101_notstarred');
function yt101_notstarred() {
    echo 'lol';
     global $wpdb;
   $id = $_POST['id'] ;
   $table_name = $wpdb->prefix . "WPTT";
   $wpdb->update( $table_name, array('starred'=>'1'), array('id'=>$id));
}


//Changes to paused
add_action('wp_ajax_yt101_play', 'yt101_play');
function yt101_play() {
    
   global $wpdb;
   $id = $_POST['id'] ;
   $table_name = $wpdb->prefix . "WPTT";
   $wpdb->update( $table_name, array('status'=>'pause'), array('id'=>$id));
	
    
}

//Changes to play.. so if the image has the pause? image, it means it's live.. like a tv remote!!
add_action('wp_ajax_yt101_pause', 'yt101_pause');
function yt101_pause() {
    
   global $wpdb;
   $id = $_POST['id'] ;
   $table_name = $wpdb->prefix . "WPTT";
   $wpdb->update( $table_name, array('status'=>'play'), array('id'=>$id));
	
    
}